%%************************************************************************
%% NTcorr: corrector step for the NT direction. 
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%************************************************************************

  function [dX,dy,dZ] = NTcorr(blk,dX,dZ,A,rp,Rd,sigma,mu,hRd,Uchol,iscmpA,W,G,sv); 
%%
    hdZ = Prod3(blk,G,dZ,ops(G,'ctranspose'),1); 
    hdX = ops(ops(ops(-1,'*',sv),'spdiags',G), '-', hdZ); 
    tmp = Prod2(blk,hdX,hdZ);  tmp = ops(tmp,'sym'); 
    clear hdX hdZ; 
    Dinv = ops(sv,'rank1inv',ops(sv,'ones'),blk); 
    Rq  = ops(Dinv,'.*',tmp);  
    clear Dinv; 

    tmp = ops( ops(ops(sigma*mu,'./',sv),'-',sv), 'spdiags', G );
    EinvRc = Prod3(blk,ops(G,'ctranspose'),ops(tmp,'-',Rq),G,1); 
    clear G  Rq;
    rhs = rp + hRd - blktrace(blk,A,EinvRc); 
%%
    dy = mexbsolve(Uchol,mexbsolve(Uchol,rhs,2),1); 
    dZ  = ops(Rd,'-',Asum(blk,A,dy,iscmpA)); 
    tmp = Prod3(blk,W,dZ,W,1); 
    dX  = ops(EinvRc,'-',tmp);
%%========================================================================




