%%******************************************
%% corrprim: correct primal infeasibility,
%%           by projection onto Null(A). 
%%
%% dX = corrprim(blk,A,dX,UA,permUA);
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%******************************************

  function dX = corrprim(blk,A,dX,UA,permUA);
    
    rhs = blktrace(blk,A,dX); 
    v   = UA\ (UA'\ rhs(permUA));
    v(permUA) = v; 
    tmp = Asum(blk,A,v);
    dX  = ops(dX,'-',tmp); 
%%==========================================
